RUNS_HUMAN_VERSION	equ	3
	.cpu 68000
	.include doscall.mac

	.text

_readBit1	macro
	local	?412,?410,?415,?endb2

	dbra d7,?410		*readbit
	dbra d6,?412
	jbsr _readData
	jbra ?410
?412
	addq.l #2,(a0)
	moveq.l #15,d7
?410
	movea.l (a0),a1
	lsl.w (a1)
	jbcc ?415
	moveq.l #1,d0
	jbra ?endb2
?415
	moveq.l #0,d0
?endb2
	endm

_readBit2	macro
	local	mokkai,?512,?510

	movea.l (a0),a1
	moveq.l #0,d1
mokkai
	dbra d7,?510
	dbra d6,?512
	jbsr _readData
	movea.l (a0),a1
	jbra ?510
?512
	addq.l #2,a1
	moveq.l #15,d7
?510
	move.w (a1),d1
	add.l d1,d1
	move.w d1,(a1)
	dbra d2,mokkai
	move.l a1,(a0)
	moveq.l #0,d0
	swap.w d1
	move.w d1,d0

	endm

_readBit	macro
	local	?21,?18,?10

	movea.l (a0),a1
	moveq.l #0,d1
	jbra ?10
?21
	moveq.l #0,d2
	move.w d7,d0
	sub.w d0,d3
	move.w (a1),d2
	lsl.l d0,d2
	move.w d2,(a1)
	swap.w d2
	lsl.l d0,d1
	or.w d2,d1
	dbra d6,?18
	jbsr _readData
	movea.l (a0),a1
	moveq.l #16,d7
	jbra ?10
?18
	addq.l #2,a1
	moveq.l #16,d7
?10
	cmp.w d7,d3
	jbgt ?21
	sub.w d3,d7
	moveq.l #0,d2
	move.w (a1),d2
	lsl.l d3,d2
	move.w d2,(a1)
	swap.w d2
	move.l a1,(a0)
	lsl.l d3,d1
	or.w d2,d1
	move.l d1,d0

	endm

_readBit7	macro
	local	?621,?618,?610

	movea.l (a0),a1
	moveq.l #0,d1
	cmp.w d7,d3
	jble ?610
?621
	sub.w d7,d3
	move.w (a1),d1
	lsl.l d7,d1
	move.w d1,(a1)
	dbra d6,?618
	jbsr _readData
	movea.l (a0),a1
	moveq.l #16,d7
	jbra ?610
?618
	addq.l #2,a1
	moveq.l #16,d7
?610
	sub.w d3,d7
	move.w (a1),d1
	lsl.l d3,d1
	move.w d1,(a1)
	swap.w d1
	move.l a1,(a0)
	moveq.l #0,d0
	move.w d1,d0

	endm

	.even
_readData:
	move.l -4(a0),-(sp)
	move.l -8(a0),-(sp)
	move.w -10(a0),-(sp)
	DOS _READ
	lea.l 10(sp),sp
	subq.w #2,d0
	lsr.w d0
	move.w d0,d6
	jbne not_empty
	moveq.l #1,d0
	move.w d0,42(a0)
not_empty:
	move.l -8(a0),(a0)
	moveq.l #15,d7
	
	rts

	.globl _loadPICfile
_loadPICfile:
	movem.l d3/d4/d5/d6/d7/a3/a4/a5,-(sp)
	lea.l _psi,a0
	pea 16384.w
	DOS _MALLOC
	move.l d0,4(a0)
	addq.w #4,sp
	jbgt memoryok
	jbra eread
memoryok:
	move.l #16384,8(a0)
	movea.l a0,a5
	lea.l 12(a0),a0
	move.w 52(a0),d7
	moveq.l #0,d2
	move.w d2,42(a0)
	move.w 2(a5),-(sp)
	DOS _FGETC
	moveq.l #80,d2
	cmp.l d0,d2
	jbne ?275
	DOS _FGETC
	moveq.l #73,d2
	cmp.l d0,d2
	jbne ?275
	DOS _FGETC
	moveq.l #67,d2
	cmp.l d0,d2
	jbne ?275
?256:
	moveq.l #26,d2
	DOS _FGETC
	cmp.l d0,d2
	jbne ?256
?258:
	DOS _FGETC
	tst.l d0
	jbne ?258
	DOS _FGETC
	tst.l d0
	jbne ?275
	DOS _FGETC
	tst.l d0
	jbne ?275
	DOS _FGETC
	tst.l d0
	jbne ?275
	DOS _FGETC
	moveq.l #15,d2
	cmp.l d0,d2
	jbeq ?263
?275:
	addq.w #2,sp
	moveq.l #101,d0
	add.w d0,d0		*PICSLICE_EFORMAT
	jbra ?252
?263:
	moveq.l #0,d2
	move.l d2,12(a5)
	DOS _FGETC
	lea 20(a5),a4
	asl.l #8,d0
	move.l d0,(a4)
	DOS _FGETC
	add.l d0,(a4)
	DOS _FGETC
	lea 24(a5),a4
	asl.l #8,d0
	move.l d0,(a4)
	DOS _FGETC
	add.l (a4),d0
	move.l d0,(a4)
	addq.l #2,sp
	move.l #512,d2
	cmp.l d2,d0
	jble ?264
	move.l d2,(a4)
?264:
	move.l d2,16(a5)
	moveq.l #0,d2
	move.l d2,28(a5)
	move.w d2,36(a5)
	move.l d2,46(a5)	*y		34(a0)
	move.l #$c00000,50(a5)	*frame		38(a0)
	move.l d2,54(a5)	*_readerror	42(a0)
	move.l d2,d6
	move.l d2,d7
	move.l a5,a1

	moveq.l #0,d1
	moveq.l #127,d2
?269:
	lea.l (a1,d1.w),a2
	clr.w 66(a2)
	subq.w #2,d1
	move.b d1,323(a2)	*prev
	addq.w #4,d1
	move.b d1,322(a2)	*next
	dbra d2,?269

	clr.w 1346(a1)
	moveq.l #1,d3
	jbra ?271
?273:
	addq.l #1,d3
?271:
	_readBit1
	jbne ?273
	move.l d3,-(sp)
	_readBit
	move.l (sp)+,d3
	move.l d0,a2
	moveq.l #1,d0
	asl.l d3,d0
	lea -2(a2,d0.l),a2
	move.l a2,32(a5)
	tst.w 54(a5)
	jbeq ?274
eread:
	move.l #203,d0		*PICSLICE_EREAD
	jbra ?252
?274:
	moveq.l #1,d0
	move.l d0,_drawing
	move.l #_drawPIC,_drawfunc
	jbsr _iclr
	move.w d6,48(a0)
	move.w d7,52(a0)
	moveq.l #100,d0
	add.w d0,d0		*PICSLICE_NORMAL
	jbra readok
?252:
	move.l d0,d7
	jbsr _EndOfDraw
	move.l d7,d0
readok:
	movem.l (sp)+,d3/d4/d5/d6/d7/a3/a4/a5
	rts
	.even
	.globl _drawPIC
_drawPIC:
	link a6,#-8
	movem.l d3/d4/d5/d6/d7/a3/a4/a5,-(sp)
	lea.l _psi+12,a0
	moveq.l #0,d5
	move.l d5,-(sp)
	DOS _SUPER
	move.l d0,-8(a6)
	addq.l #4,sp
	move.l d5,d4
	move.w d5,42(a0)
	move.l d5,d7
	move.w 48(a0),d6
	move.w 52(a0),d7
	move.w 14(a0),-2(a6)	*height
	movea.l	8(a0),a4	*width
	move.w	18(a0),a3	*currenty
	move.l	20(a0),a5	*runlength
	move.l	a4,d1		*width
	move.w	#512,d3
	cmp.w	d3,d1
	ble	under512_init
	move.w	d3,d1
under512_init:
	move.w d1,-4(a6)
?277:
	lea.l 24(a0),a1		*color
	jbra ?280
?297:
	move.l a4,d0	*width
	sub.l d5,d0
	sub.l d0,a5	*runlength
	addq.w #1,d4
	moveq.l #0,d5
?283:
	movea.l	38(a0),a2	*frame
	move.w	-4(a6),d1	*width
	move.w (a1),d2
	jbra ?288
?294:
	move.w (a2),d0	*frame
	ror.b #1,d0
	jbpl ?293
	add.b d0,d0
	move.w d0,d2
?293:
	move.w d2,(a2)+	*color->frame
?288:
	dbra	d1,?294
	move.w d2,(a1)	*color
	add.l	#1024,38(a0)	*frame+= 1024

	addq.w #1,a3
	move.w a3,d0		*currenty
	cmp.w -2(a6),d0
	jbne ?296
	move.l #201,d0		*PICSLICE_TERMINATE
	jbra ?276
?296:
	cmp.w _dy+2,d4		*raster(dy)
	jbne ?280
	moveq.l #100,d0
	add.w d0,d0		*PICSLICE_NORMAL
	jbra ?276
?280:
	move.l d5,d0
	add.l a5,d0		*runlength
	cmp.l a4,d0		*width
	jbge ?297
	add.l a5,d5		*runlength

_readColor:
	_readBit1
	jbne ?246
	moveq.l #15,d3
	_readBit7
	lea 1334(a0),a1	*current
	move.w (a1),d1
	lea.l -12(a0,d1.w),a2
	move.b 322(a2),d3
	move.w d3,(a1)
	add.w d0,d0
	move.w d0,54(a0,d3.w)
	move.w d0,d3
	jbra ?251
?246:
	moveq.l #7,d3
	_readBit7
	move.l d0,d2
	add.w d2,d2
	move.w 1334(a0),d1
	cmp.w d1,d2
	jbeq ?250
	lea 310(a0),a1		*prev
	lea.l (a1,d2.w),a2
	move.b (a2)+,d0		*prev[idx]
	move.b (a2),d3		*next[idx]
	move.b d1,(a2)		*cc->next[idx]
	move.b d0,(a1,d3.w)	*prev[idx]->prev[next[idx]]
	move.b d3,1(a1,d0.w)	*next[idx]->next[prev[idx]]
	move.b (a1,d1.w),d0	*prev[cc]
	move.b d0,-(a2)		*prev[cc]->prev[idx]
	move.b d2,1(a1,d0.w)	*idx->next[prev[cc]]
	move.b d2,(a1,d1.w)	*idx->prev[cc]

	move.w d2,1334(a0)	*idx->current
?250:
	move.w 54(a0,d2.w),d3	*color[idx]
?251:
	or.w #1,d3
	tst.w 42(a0)
	jbne ?307
	cmp.l	#511,d5
	bgt	over_512_x
	move.l d5,d0
	add.w d0,d0
	movea.l 38(a0),a2	*frame
	move.w d3,(a2,d0.w)
over_512_x:
	_readBit1
	tst.w 42(a0)
	jbne ?307
	cmpi.w #1,d0
	jbne ?300
_expandChain:
	move.l d5,-(sp)
	swap.w d4
	move.w 14(a0),d4	*height
	sub.w a3,d4		*currenty
	subq.w #1,d4
	movea.l 38(a0),a2	*frame
?80:
	moveq.l #2-1,d2
	_readBit2
	dbra d0,?88
?84:
	_readBit1
	jbeq ?147
	_readBit1
	jbne ?86
	subq.w #2,d5
	jbra ?83
?86:
	addq.w #2,d5
	jbra ?83
?88:
	dbra d0,?b2
	subq.w #1,d5
	jbra ?83
?90:
	addq.w #1,d5
	jbra ?83
?b2:
	dbra d0,?90
?83:
	lea.l 1024(a2),a2	*frame
	tst.w d5
	jblt ?98
	cmp.w 10(a0),d5		*width
	jbge ?98
	dbra d4,?93		*height
?98:
	moveq.l #2-1,d2
	_readBit2
	jbne ?98
	_readBit1
	jbeq ?147
	_readBit1
	jbra ?98
?93:
	cmpi.w #511,d5
	jbgt ?80
	move.w d5,d0
	add.w d0,d0
	move.w d3,(a2,d0.w)
	jbra ?80
?147:
	moveq.l #100,d0
	add.w d0,d0		*PICSLICE_NORMAL
?79:
	swap.w d4
	move.l (sp)+,d5
	cmp.w #200,d0		*PICSLICE_NORMAL
	jbne ?276
?300:
	moveq.l #1,d3
	jbra ?303
?305:
	addq.w #1,d3
?303:
	_readBit1
	jbne ?305
	movea.l d3,a2
	_readBit
	move.l a2,d3
	move.l d0,a2
	moveq.l #1,d0
	asl.l d3,d0
	lea -1(a2,d0.l),a5	*runlength
	tst.w 42(a0)
	jbeq ?277
?307:
	move.l #203,d0		*PICSLICE_EREAD
?276:
	move.w d7,52(a0)
	move.w d6,48(a0)
	move.l a5,20(a0)
	move.w a3,18(a0)
	move.l a4,8(a0)
	move.l d0,d7
	move.l -8(a6),-(sp)
	DOS _SUPER
	addq.l #4,sp
	cmp.w #200,d7
	jbeq normalret
	move.l #512,4(a0)
	pea.l 54(a0)	
	jbsr _getgmode
	addq.l #4,sp
	jbsr _EndOfDraw
	clr.l -(sp)
	DOS _SUPER
	move.l d0,d6
	addq.l #4,sp
	jbsr _RectPut
	move.l d6,-(sp)
	DOS _SUPER
	addq.l #4,sp
normalret:
	move.l d7,d0
	movem.l (sp)+,d3/d4/d5/d6/d7/a3/a4/a5
	unlk a6
	rts
	.even
	.end
